#include "itkCommand.h"

class FilterProgressPrinter : public itk::Command
{

public:
  typedef FilterProgressPrinter Self;
  typedef itk::Command         Superclass;
  typedef itk::SmartPointer<Self>  Pointer;
  itkNewMacro( Self );


public:

  typedef itk::ProcessObject ProcessObjectType;
  typedef const ProcessObjectType * ProcessObjectTypePointer;
  
  void Execute( itk::Object *caller, const itk::EventObject & event )
    {
    Execute( (const itk::Object *)caller, event);
    }
  void Execute( const itk::Object * object, const itk::EventObject & event )
    {
    ProcessObjectTypePointer process_object = 
      dynamic_cast< ProcessObjectTypePointer >( object );
    if( itk::ProgressEvent().CheckEvent( &event ) )
      {
      std::cout 
        << process_object->GetNameOfClass() << " " 
        << process_object->GetProgress() 
        << std::endl;
      std::cout.flush();
      }
    }
};
